from Products.CMFCore.CMFCorePermissions import ManagePortal
from Products.CMFCore.utils import getToolByName
from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.MediaDB.config import packageName, packageGlobals, toolId
from StringIO import StringIO

configlet = {
    'id': toolId,
    'name': 'Media DB Settings',
    'appId': 'Media DB',
    'action': 'string:${portal_url}/%s/media_db_prefs' % toolId,
    'category': 'Plone',
    'permission': ManagePortal,
    'imageUrl': 'media_db_icon.gif',
    'visible': False,
}


def install(self):
    """ install the product, tools, skins etc """
    out = StringIO()
    installTypes(self, out, listTypes(packageName), packageName)
    install_subskin(self, out, packageGlobals)

    if not hasattr(self, toolId):
        self.manage_addProduct['MediaDB'].manage_addTool('Media DB')

    actionsTool = getToolByName(self, 'portal_actions')
    actionsTool.manage_aproviders(toolId, add_provider=1)

    configTool = getToolByName(self, 'portal_controlpanel')
    configTool.registerConfiglet(**configlet)
    out.write('Added %s configlet\n' % packageName)

    print >> out, 'Successfully installed %s.' % packageName
    return out.getvalue()


def uninstall(self):
    """ remove the product, tools, skins etc """
    out = StringIO()
    actionTool = getToolByName(self, 'portal_actions')
    actionTool.deleteActionProvider(toolId)
    out.write('Removed action provider\n')

    configTool = getToolByName(self, 'portal_controlpanel')
    configTool.unregisterConfiglet(toolId)
    out.write('Removed %s configlet\n' % packageName)

    return out.getvalue()

