from PIL.Image import open
from os import popen


def mediaInfo(media):
    """ return info for media object based on mime type """
    path = media.getFilepath()
    type = mediaType(path)
    main, sub = type.split('/', 1)
    if types.has_key(type):
        info = types[type](media, type, path)
    elif types.has_key(main):
        info = types[main](media, type, path)
    else:
        info = {}
    return info


def mediaType(path):
    """ determine mime type via 'file' command """
    pipe = popen('file -ib %s' % path)
    return pipe.read().strip()


def imageInfo(media, type, path):
    """ return info for image objects """
    img = open(path)
    return {
        'width': img.size[0],
        'height': img.size[1],
	'format': img.format,
	'mode': img.mode,
        # 'info': img.info,
    }


def videoInfo(media, type, path):
    """ return info for video objects """
    path = media.getFilepath()
    pipe = popen('mplayer -identify -quiet -frames 0 %s' % path)
    info = {}
    for line in pipe.readlines():
        if line[:3] == 'ID_':
	    key, value = line.split('=', 1)
	    key = key.lower()[3:]
	    info[key] = value.strip()
    return info


def pdfInfo(media, type, path):
    """ return info for pdf documents """
    path = media.getFilepath()
    pipe = popen('pdfinfo %s' % path)
    info = {}
    for line in pipe.readlines():
	key, value = line.split(':', 1)
	info[key] = value.strip()
    return info


types = {
    'video': videoInfo,
    'image': imageInfo,
    'application/pdf': pdfInfo,
}

