from Products.Archetypes.public import *
from Products.ATManagedFile.schema import ManagedFileField, ManagedFileWidget, ManagedFileStorage


AccessMediaData = 'Access media data'


DescriptionField = TextField('description',
    searchable = True,
    accessor = 'Description',
    widget = TextAreaWidget(
        label = 'Description',
        label_msgid = 'label_description',
        description_msgid = 'help_description',
        i18n_domain = 'plone'))


MediaObjectSchema = BaseSchema + Schema((
    DescriptionField,
    StringField('archiveNumber',
        searchable = True,
        widget = StringWidget(
            label = 'Archive Number',
            label_msgid = 'label_archive_number',
	    description = 'Enter the archive number of this media object.',
            description_msgid = 'help_archive_number',
            i18n_domain = 'kmdb'),
    ),
    FileField('data',
        languageIndependent = True,
	mode = 'r',
        read_permission = AccessMediaData,
        widget = FileWidget(
            label = 'Data',
            label_msgid = 'label_media_data',
            description = 'Select the media file or image by clicking the \'Browse\' button.',
            description_msgid = 'help_media_data',
            i18n_domain = 'kmdb'),
    ),
    ManagedFileField('file',
        primary = True,
        required = True,
        languageIndependent = True,
        read_permission = AccessMediaData,
        storage = ManagedFileStorage(),
        widget = ManagedFileWidget(
            label = 'File',
            label_msgid = 'label_media_file',
            i18n_domain = 'kmdb'),
    ),
    StringField('repository',
        vocabulary = 'getRepositories',
        widget = SelectionWidget(
	    label = 'Target Repository'),
    ),
    StringField('deletePolicy',
        vocabulary = 'getDeletePolicies',
        widget = SelectionWidget(
	    label = 'Deletion Policy'),
    ),
  ), marshall = PrimaryFieldMarshaller()
)

