## Script (Python) "media_item_share"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=site, references=None
##title=Set local roles for the given media items
##
from Products.CMFCore.utils import getToolByName
rtool = getToolByName(container, 'reference_catalog')
lookup = rtool.lookupObject

state.setNextAction('redirect_to:request/action')

if not references:
    message = ('Please select one or more objects.', 'select_objects_first')
    errors = { 'reference': message }
    return state.set(status='failure', errors=errors, portal_status_message=message[0])

role = 'Media Access'
titles = []
for ref in references:
    obj = lookup(ref)
    obj.manage_addLocalRoles(site, (role,))
    obj.reindexObject()
    titles.append(obj.Title())

context.REQUEST.SESSION['current_site'] = site

message = 'Sharing enabled for site "%s". (%s)' % (site, ', '.join(titles))
return state.set(status='success', portal_status_message=message, selected_references=references)
