## Script (Python) "media_keywords_add"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=references=None, referencedSynonyms=[]
##title=Set keywords for the given media items
##
from Products.CMFCore.utils import getToolByName
ktool = getToolByName(container, 'portal_keywordmanager')
rtool = getToolByName(container, 'reference_catalog')
lookup = rtool.lookupObject

state.setNextAction('traverse_to:request/action')

if not references:
    message = ('Please select one or more objects.', 'select_objects_first')
    errors = { 'reference': message }
    return state.set(status='failure', errors=errors, portal_status_message=message[0])

titles = []
for ref in references:
    obj = lookup(ref)
    uid = obj.UID()
    syns = ktool.getReferencedSynonyms(uid, lang=None)
    rsyns = [sid for sid in referencedSynonyms if not sid in syns]
    ktool.addReferencedSynonyms(uid, tuple(syns) + tuple(rsyns))	# add actually replaces all synonyms
    titles.append(obj.Title())

message = 'Keywords set for %s.' % ', '.join(titles)
return state.set(status='success', portal_status_message=message)
