## Script (Python) "media_search"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=
##title=Performs search for media objects and stores the results
##
from Products.CMFCore.utils import getToolByName

request = context.REQUEST
session = request.SESSION
session['search_criteria'] = request.form.copy()

for n in ('Title', 'SearchableText'):
    value = request.get(n)
    if value and not '*' in value:
        request.set(n, '*%s*' % value)

for n in ('size', 'resolution'):
    value = request.get(n, None)
    if value:
        request.set(n, {
            'query': map(int, value.split(':', 1)),
            'range': 'minmax',
	})

for n in ('created', 'modified', 'effective', 'expires'):
    value = request.get(n, None)
    try: request.set(n, DateTime(value))
    except: pass
    
results = []
relevance = {}
for brain in context.queryCatalog():
    results.append(brain.UID)
    relevance[brain.UID] = brain.data_record_normalized_score_

usedBy = request.get('usedBy', None)
if usedBy:
    mdb = getToolByName(container, 'media_db')
    counts = mdb.mediaReferenceCounts(results)
    for site in usedBy:
        results = [uid for uid in results if counts[uid][site] > 0]

session['search_results'] = results
session['search_relevance'] = relevance

if results: status = 'success'
else: status = 'failure'

message = '%d matche(s) found.' % len(results)
return state.set(status=status, portal_status_message=message)
