## Script (Python) "value_vocabulary"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=index, count=8
##title=Returns a set of options for a given numerical catalog index
##
from Products.CMFCore.utils import getToolByName
ctool = getToolByName(container, 'portal_catalog')


def longest(values):
    """ return the index of the longest element of the given list """
    m = 0
    n = 0
    for i in range(len(values)):
        l = len(values[i])
        if l > m:
	    m = l
	    n = i
    return n


def split(value, factor):
    """ split the given list into two parts, also returning boundaries """
    ln = len(value)
    avg = float(sum(value)) / ln
    cut = round(int(avg / factor)) * factor
    for i in range(ln):
        if value[i] > cut:
	    break
    i = max(i, 1)
    i = min(ln - 1, i)
    return value[:i], value[i:], int(cut)


values = ctool.uniqueValuesFor(index)
maximum = max(values)
minimum = min(values)

print 'val: ', values
print 'max: ', float(maximum)
print 'min: ', float(minimum)

factor = 1.0
scale = 1024
dimensions = ('', 'k', 'M', 'G')
value = float(maximum)
for dim in dimensions:
    if value < scale:
        break
    value /= scale
    factor *= scale

digits = 0
if value < 10:
    factor /= 10
    digits = 1

print 'dim: ', dim
print 'fac: ', factor
print

total = len(values)
print 'total: ', total
values = [values]
boundaries = [int(minimum / factor), int(maximum / factor) + 1]
boundaries = [int(b * factor) for b in boundaries]

while len(values) < count:
    n = longest(values)
    l = values[n]
    print 'longest: ', n, l
    if len(l) < count and not len(values) == 1 or not l:
        break
    print 'splitting... ', factor, l
    a, b, cut = split(l, factor)
    print 'split... ', cut, a, b
    if cut in boundaries[n:n+1]:
        break
    values[n:n+1] = a, b
    boundaries[n+1:n+1] = [cut]
    for v in values:
        print '  ', len(v), v
    print 'boundaries: ', boundaries
    print

fmt = '%%.%df' % digits
for b in boundaries:
    print ('%s ... ' + fmt) % (b, b / factor / 10 ** digits)
print

ranges = []
for n in range(len(boundaries) - 1):
    low, high = boundaries[n:n+2]
    ranges.append({
        'low': low,
        'high': high,
	'factor': factor * 10 ** digits,
	'format': fmt,
	'dimension': dim,
	'count': len(values[n]),
    })
    print ranges[-1]

return ranges
