from threading import Thread, BoundedSemaphore, enumerate, currentThread
from whrandom import randint
from time import sleep, time


def runner(name, sema, list):
    secs = randint(5, 20)
    until = time() + secs
    print 'thread %s: sleeping for %d seconds...' % (name, secs)
    while time() < until:
        print 'thread %s: still sleeping %.2f seconds' % (name, until - time())
        sleep(1)
    print 'thread %s: acquiring...' % name
    sema.acquire()
    list.append((name, secs))
    sema.release()
    print 'thread %s: released...' % name


def test():
    sema = BoundedSemaphore()
    threads = []
    list = []
    for n in range(1, 4):
        args = (n, sema, list)
        t = Thread(target=runner, name=n, args=args)
        t.start()
        threads.append(t)
    for t in threads:
        t.join()
    print 'done'


test()

